lib/billout_web/router.ex
defmodule BilloutWeb.Router do
  use BilloutWeb, :router
  use Pow.Phoenix.Router
  use Pow.Extension.Phoenix.Router, otp_app: :billout


  pipeline :browser do
    plug :accepts, ["html"]
    plug :fetch_session
    plug :fetch_flash
    plug :protect_from_forgery
    plug :put_secure_browser_headers

  end

    pipeline :protected do
    plug Pow.Plug.RequireAuthenticated,
      error_handler: Pow.Phoenix.PlugErrorHandler
  end

  pipeline :api do
    plug :accepts, ["json"]
  end


  scope "/" do
    pipe_through :browser
    pow_extension_routes()
    resources "/login", BilloutWeb.LoginController
    pow_routes()

  end

 # Scopes that require authentication
  scope "/", BilloutWeb do
    pipe_through [:browser, :protected]
    get "/logout", LogoutController, :index
    post "/employees/role", EmployeeController, :change_role #Route for obsolete role tab
    post "/employees/roles", EmployeeController, :change_roles
    get "/employees/reset", EmployeeController, :load_reset
    post "/employees/reset", EmployeeController, :handle_reset
    post "/employees", EmployeeController, :create
    get "/employees/package/:id", EmployeeController, :retrieve
    get "/", PageController, :index
    get "/employees/sample/download", EmployeeController, :download_sample
    get "/employees/upload", EmployeeController, :new_upload
    post "/employees/upload", EmployeeController, :upload
    put "/employees", EmployeeController, :update
    resources "/employees", EmployeeController
    get "/employees/sort", EmployeeController, :sort
    get "/settings", SettingsController, :index
    get "/settings/roles", SettingsController, :manage_role
    get "/settings/packages", SettingsController, :package
    resources "/payroll", PayrollController
    resources "/user/payroll", EmployeeRoleController

  end

  # Other scopes may use custom stacks.
  scope "/api", BilloutWeb.Api, as: :api do
    pipe_through [:api, :protected]
    resources "/payroll", PayrollController
    resources "/earnings", EarningController
    resources "/employees", EmployeeController
    resources "/packages", PackageController
    post "/package", PackageController, :create_package
    resources "/countries", CountryController, only: [:index, :show]
    get "/states/:country_id", StateController, :state_country
    get "/package_earnings/:package_id", EarningController, :package_earnings
    get "/list_packages", PackageController, :list_packages
    post "/assign_package", PackageController, :create_employee_package
    post "/earnings/upsert", EarningController, :update_or_insert
    post "/ledger", LedgerController, :create
    get "/user/payroll", PayrollController, :user_index
    post "/deduction", DeductionController, :create
    post "/settings/new_role", SettingsController, :add_role
    post "/settings/change_role", SettingsController, :edit_role
    get "/deductions/:package_id", DeductionController, :package_deductions
    get "/employeedeductions/:employee_id", DeductionController, :employee_deductions
    get "/settings/get_role", SettingsController, :get_roles
    get "/ledger/previous", PayrollController, :previous
    get "/payroll/previous/:payrun_id", PayrollController, :previous_payrun
    get "/earnings/employee/:employee_id", EarningController, :employee_earnings
    resources "/payrun", PayrunController
  end


end

lib/billout_web/controllers/login_controller.ex
defmodule BilloutWeb.LoginController do
  use BilloutWeb, :controller

  def index(conn, _params) do
    changeset = Pow.Plug.change_user(conn)
    render conn, "index.html", changeset: changeset, msg: "", layout: {BilloutWeb.LayoutView, "login.html"}
  end

  def create(conn, %{"user" => user_params}) do 
    conn
    |> Pow.Plug.authenticate_user(user_params)
    |> case do
      {:ok, conn} ->
        conn
          |> redirect(to: Routes.page_path(conn, :index))

      {:error, conn} ->
        changeset = Pow.Plug.change_user(conn, conn.params["user"])

        conn
          |> render("index.html", changeset: changeset, msg: "error", layout: {BilloutWeb.LayoutView, "login.html"})
    end
  end
end

lib/billout_web/views/login_view.ex
defmodule BilloutWeb.LoginView do
  use BilloutWeb, :view
end

lib/billout_web/templates/login/index.html.eex
<div class="outer-container">
  <div class="header-container text-center"> 
    <img src="/images/icons/billout_header.svg" alt="Billout icon" class="billout-icon">
    <span class="billout-header">Billout </span>
  </div>
  <div class="inner-container">
    <div class="login-text text-center">Login to access your account</div>
    <div class="form-container">     
     <%= form_for @changeset, Routes.login_path(@conn, :create), [as: :user], fn f -> %>
      <input name="_method" type="hidden" value="post">
        <%= if @changeset.action do %>
          <div class="alert alert-danger">
            <p>Oops, something went wrong! Please check the errors below.</p>
          </div>
        <% end %>
        <div class="columns ">
          <div class="column col-12">
            <div class="form-group">
            <%= if @msg == "error"  do %>
              <div class="login_error_notification">*Email or Password incorrect</div><br/>
            <% end %> 
            <%= if @msg == "updated"  do %>
              <div class="reset_notification"><img src="<%= Routes.static_path(@conn, "/images/icons/checkbox.svg") %>" alt="Billout icon" class="billout-icon" width=13px height=13px/><span class="reset-text">Password reset link sent succesfully </span></div><br/>
            <% end %> 
            </div>
          </div>
        </div>
        <div class="columns ">
          <div class="column col-12">
            <div class="form-group">
              <%= label f, Pow.Ecto.Schema.user_id_field(@changeset) %><br/>
              <%= if @msg == "error"  do %>
              <%= text_input f, Pow.Ecto.Schema.user_id_field(@changeset), class: "new_form_input form_input_margin form_error_style" %><br/>
              <% end %> 
              <%= if @msg !== "error"  do %>
                <%= text_input f, Pow.Ecto.Schema.user_id_field(@changeset), class: "new_form_input form_input_margin" %><br/>
              <% end %> 
              <%= error_tag f, Pow.Ecto.Schema.user_id_field(@changeset) %>
            </div>
          </div>
        </div>
        <div class="columns new_cl">
          <div class="column col-12">
            <div class="form-group">
              <%= label f, :password %><br/>
                <%= if @msg == "error"  do %>
                <%= password_input f, :password, class: "new_form_input form_input_margin form_error_style" %><br/>
                <% end %> 
                <%= if @msg !== "error"  do %>
                <%= password_input f, :password, class: "new_form_input form_input_margin" %><br/>
                <% end %> 
              <%= error_tag f, :password %>
            </div>
          </div>
        <div class="columns column col-12 login-btn-container">
          <div class="column col-6"><button type="submit" class="btn submit_btn4">Login</button></div>
          <div class="column col-6 text-right forgot_text_div"><a href="/reset-password/new" class="forgot-password-text">Forgot Password?</a></div>
        </div>        
      <% end %>
    </div>
  </div>
</div>